-- Projeto cronmetro
--
-- Circuitos Lgicos 	2006	Prof. Srgio
-- Pontificia Universidade Catolica de Campinas
--
-- Cesar Kallas			cesarkallas at gmx.net		RA: 02099224
-- Sergio Luis Silva	sergioteacher at gmail.com	RA: 02593952
--
-- Construa um cronmetro que exibe os segundos de 0 at 59
-- (ao chegar ao segundo 59 deve voltar para o 0). 
-- As sadas devem ser os dgitos de 1 e 2. O boto 28 deve ser o reset.
--
-- Clock interno
-- O pino 91 emite sinais com a frequncia de 25.175.000 Hz
-- ou seja:
-- ___     ___     ___     ___
--    |___|   |___|   |___|
--
-- Saidas: display 1 e display 2

entity projeto12 is
	port(
		inicia, reset: in bit;
		display1: out bit_vector(1 to 7);
		display2: out bit_vector(1 to 7));
end projeto12;

architecture arqProjeto12 of projeto12 is
begin
	process(inicia, reset)
		variable tamSegundo: integer range 0 to 25175000;
		variable segundos: integer range 0 to 59;
		variable quociente : integer range 0 to 6;
		variable mode : integer range 0 to 9;
	begin
	
		if inicia'event and inicia = '1' then
			tamSegundo:= tamSegundo + 1;
			if tamSegundo = 25175000 then
					tamSegundo := 0;
					segundos:= segundos + 1;
			end if;
		end if;

		if segundos = 60 then
			segundos := 0;
		end if;
	
		if  reset = '0' then
			segundos:= 0;
			quociente := 0;
			mode:= 0;
		end if;
	
		quociente := segundos / 10;
		mode := segundos mod 10;
	
		case quociente is
			when 0 =>	-- 0
				display1 <= "0000001";
			when 1 =>	-- 1
				display1 <= "1001111";
			when 2 =>	-- 2
				display1 <= "0010010";
			when 3 =>	-- 3
				display1 <= "0000110";
			when 4 =>	-- 4
				display1 <= "1001100";
			when 5 =>	-- 5
				display1 <= "0100100";
			when 6 =>	-- 6
				display1 <= "0100000";
			when 7 =>	-- 7
				display1 <= "0001111";
			when 8 =>	-- 8
				display1 <= "0000000";
			when 9 =>	-- 9
				display1 <= "0001100";
			when others =>	-- tudo apagado
				display1 <= "1111111";
		end case;
		case mode is
			when 0 =>	-- 0
				display2 <= "0000001";
			when 1 =>	-- 1
				display2 <= "1001111";
			when 2 =>	-- 2
				display2 <= "0010010";
			when 3 =>	-- 3
				display2 <= "0000110";
			when 4 =>	-- 4
				display2 <= "1001100";
			when 5 =>	-- 5
				display2 <= "0100100";
			when 6 =>	-- 6
				display2 <= "0100000";
			when 7 =>	-- 7
				display2 <= "0001111";
			when 8 =>	-- 8
				display2 <= "0000000";
			when 9 =>	-- 9
				display2 <= "0001100";
			when others =>	-- tudo apagado
				display2 <= "1111111";
		end case;
	end process;
end arqProjeto12;