-- Projeto contador com clock
--
-- Circuitos Lgicos 	2006	Prof. Srgio
-- Pontificia Universidade Catolica de Campinas
--
-- Cesar Kallas			cesarkallas at gmx.net		RA: 02099224
-- Sergio Luis Silva	sergioteacher at gmail.com	RA: 02593952
--
-- Descricao:
-- Projeto um circuito logico que conta de 0 at 99, ao chegar
-- no nmero 99 deve voltar para o 0).
-- As sadas devem ser os digitos 1 e 2.
-- Deve haver relgio interno com pulso de 1 segundo, cada vez
-- que o relgio muda de 0 para 1, deve verificar se o boto 29
-- est pressionado, caso esteja, o display deve ser incrementado.
-- O boto 28 deve ser o reset, quando apertado, deve zerar o display.


entity projeto13 is
	port(
		botao29, inicia, reset: in bit;
		display1: out bit_vector(1 to 7);
		display2: out bit_vector(1 to 7));
end projeto13;

architecture arqProjeto13 of projeto13 is
begin
	process(botao29, inicia, reset)
		variable contador: integer range 0 to 99;
		variable tamSegundo: integer range 0 to 25175000;
		variable quociente : integer range 0 to 6;
		variable mode : integer range 0 to 9;
	begin
	
		--- Faz o controle de segundo a segundo
		if inicia'event and inicia = '1' then
			tamSegundo:= tamSegundo + 1;

			--- Chegou a um segundo
			if tamSegundo = 25175000 then
				if botao29 = '0' then
					contador := contador + 1;
				end if;
				tamSegundo := 0;
			end if;

		end if;

		if contador = 99 then
			contador := 0;
		end if;
	
		if  reset = '0' then
			contador := 0;
			quociente := 0;
			mode:= 0;
		end if;
	
		quociente := contador / 10;
		mode := contador mod 10;
	
		case quociente is
			when 0 =>	-- 0
				display1 <= "0000001";
			when 1 =>	-- 1
				display1 <= "1001111";
			when 2 =>	-- 2
				display1 <= "0010010";
			when 3 =>	-- 3
				display1 <= "0000110";
			when 4 =>	-- 4
				display1 <= "1001100";
			when 5 =>	-- 5
				display1 <= "0100100";
			when 6 =>	-- 6
				display1 <= "0100000";
			when 7 =>	-- 7
				display1 <= "0001111";
			when 8 =>	-- 8
				display1 <= "0000000";
			when 9 =>	-- 9
				display1 <= "0001100";
			when others =>	-- tudo apagado
				display1 <= "1111111";
		end case;
		case mode is
			when 0 =>	-- 0
				display2 <= "0000001";
			when 1 =>	-- 1
				display2 <= "1001111";
			when 2 =>	-- 2
				display2 <= "0010010";
			when 3 =>	-- 3
				display2 <= "0000110";
			when 4 =>	-- 4
				display2 <= "1001100";
			when 5 =>	-- 5
				display2 <= "0100100";
			when 6 =>	-- 6
				display2 <= "0100000";
			when 7 =>	-- 7
				display2 <= "0001111";
			when 8 =>	-- 8
				display2 <= "0000000";
			when 9 =>	-- 9
				display2 <= "0001100";
			when others =>	-- tudo apagado
				display2 <= "1111111";
		end case;
	end process;
end arqProjeto13;